---
title: MediaDevices.getSupportedConstraints()
slug: Web/API/MediaDevices/getSupportedConstraints
tags:
  - API
  - Media
  - Media Capture and Streams API
  - Media Streams API
  - MediaDevices
  - Method
  - Reference
  - WebRTC
  - getSupportedConstraints
---
<p>{{APIRef("Media Capture and Streams")}}</p>

<p>The <code><strong>getSupportedConstraints</strong></code><strong><code>()</code></strong> method of the {{domxref("MediaDevices")}} interface returns an object based on the {{domxref("MediaTrackSupportedConstraints")}} dictionary, whose member fields each specify one of the constrainable properties the {{Glossary("user agent")}} understands.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>supportedConstraints</em> = navigator.mediaDevices.getSupportedConstraints();</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>A new object based on the {{domxref("MediaTrackSupportedConstraints")}} dictionary listing the constraints supported by the user agent. Because only constraints supported by the user agent are included in the list, each of these Boolean properties has the value <code>true</code>.</p>

<h2 id="Example">Example</h2>

<p>This example outputs a list of the constraints supported by your browser.</p>

<div class="hidden">
<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;p&gt;The following media constraints are supported by your browser:&lt;/p&gt;

&lt;ul id="constraintList"&gt;
&lt;/ul&gt;</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css">body {
  font: 15px Arial, sans-serif;
}</pre>

<h3 id="JavaScript">JavaScript</h3>
</div>

<pre class="brush: js">let constraintList = document.getElementById("constraintList");
let supportedConstraints = navigator.mediaDevices.getSupportedConstraints();

for (let constraint in supportedConstraints) {
  if (supportedConstraints.hasOwnProperty(constraint)) {
    let elem = document.createElement("li");

    elem.innerHTML = "&lt;code&gt;" + constraint + "&lt;/code&gt;";
    constraintList.appendChild(elem);
  }
}</pre>

<h3 id="Result">Result</h3>

<p>{{ EmbedLiveSample('Example', 600, 350) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Media Capture', '#dom-mediadevices-getsupportedconstraints', 'getSupportedConstraints()')}}</td>
   <td>{{Spec2('Media Capture')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaDevices.getSupportedConstraints")}}</p>
